/*hdr
**	FILE:		Memory.h
**	AUTHOR:		Matthew Allen
**	DATE:		30/11/93
**	DESCRIPTION:	Memory subsystem header
**
**
**	Copyright (C) 1995, Matthew Allen
**		55 Kensignton Rd, Bolwarra, 2320, NSW, Australia
**		fret@ozemail.com.au
*/

#ifndef __MEMORY_H
#define __MEMORY_H

#include "device.h"

// #define MEMORY_DEBUG

#ifdef MEMORY_DEBUG

	extern void *operator		new(unsigned size, char *file, int line);
	extern void *operator		new[](unsigned size, char *file, int line);
	#define NEW(obj)		new(__FILE__, __LINE__) obj
	extern void operator		delete(void *p);

#else

	#define NEW(obj)		new obj

#endif

#define DeleteObj(obj)		if (obj) { delete obj; obj = 0; }
#define DeleteArray(obj)	if (obj) { delete [] obj; obj = 0; }

class MemoryDevice : public GDevice {

public:
	MemoryDevice();
	~MemoryDevice();

	static int GetFreeMemory() { return 0; }
};

extern void MemorySizeToStr(char *Str, uint Size);
extern int StrICmp(char *a, char *b);
extern int strnicmp(char *a, char *b, int n);
extern char *strnstr(char *a, char *b, int n);
extern char *strnistr(char *a, char *b, int n);
extern char *stristr(char *a, char *b);
extern char *TrimStr(char *s, char *Delim = " \r\n\t");
extern bool ValidStr(char *s);
extern void FormatSize(char *Str, int Size);

#endif
